﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.31
@EndOfDesignText@
'Static code module
Sub Process_Globals
End Sub

private Sub getMap(amap As Map,akey As String,adefault As Object) As Object
	Try
		Return amap.GetDefault(akey,adefault)
	Catch
		Log("[modValue.bas] -> [getMap] -> [" & LastException.message & "]")
		Return Null
	End Try
End Sub

private Sub getList(alist As List,akey As Int,adefault As Object) As Object
	Try
		If akey>=0 And akey<=alist.Size Then
			Return alist.Get(akey)
		Else
			Return adefault
		End If
	Catch
		Log("[modValue.bas] -> [getList] -> [" & LastException.message & "]")
		Return Null
	End Try
End Sub

private Sub getArray_B(aarray() As Byte,akey As Int) As Object
	Try
		Return aarray(akey)
	Catch
		Log("[modValue.bas] -> [getArray_B] -> [" & LastException.message & "]")
		Return Null
	End Try
End Sub

private Sub getArray_C(aarray() As Char,akey As Int) As Object
	Try
		Return aarray(akey)
	Catch
		Log("[modValue.bas] -> [getArray_C] -> [" & LastException.message & "]")
		Return Null
	End Try
End Sub

private Sub getArray_S(aarray() As Short,akey As Int) As Object
	Try
		Return aarray(akey)
	Catch
		Log("[modValue.bas] -> [getArray_S] -> [" & LastException.message & "]")
		Return Null
	End Try
End Sub

private Sub getArray_I(aarray() As Int,akey As Int) As Object
	Try
		Return aarray(akey)
	Catch
		Log("[modValue.bas] -> [getArray_I] -> [" & LastException.message & "]")
		Return Null
	End Try
End Sub

private Sub getArray_J(aarray() As Long,akey As Int) As Object
	Try
		Return aarray(akey)
	Catch
		Log("[modValue.bas] -> [getArray_J] -> [" & LastException.message & "]")
		Return Null
	End Try
End Sub

private Sub getArray_F(aarray() As Float,akey As Int) As Object
	Try
		Return aarray(akey)
	Catch
		Log("[modValue.bas] -> [getArray_F] -> [" & LastException.message & "]")
		Return Null
	End Try
End Sub

private Sub getArray_D(aarray() As Double,akey As Int) As Object
	Try
		Return aarray(akey)
	Catch
		Log("[modValue.bas] -> [getArray_D] -> [" & LastException.message & "]")
		Return Null
	End Try
End Sub

private Sub getArray_L(aarray() As String,akey As Int) As Object
	Try
		Return aarray(akey)
	Catch
		Log("[modValue.bas] -> [getArray_L] -> [" & LastException.message & "]")
		Return Null
	End Try
End Sub

private Sub getArrayOfMap(aarray() As Map,akey As Int) As Object
	Try
		Return aarray(akey)
	Catch
		Log("[modValue.bas] -> [getArrayOfMap] -> [" & LastException.message & "]")
		Return Null
	End Try
End Sub

private Sub getArrayOfList(aarray() As List,akey As Int) As Object
	Try
		Return aarray(akey)
	Catch
		Log("[modValue.bas] -> [getArrayOfList] -> [" & LastException.message & "]")
		Return Null
	End Try
End Sub

private Sub getArrayOfArray(aarray() As Object,akey As Int) As Object
	Try
		Return aarray(akey)
	Catch
		Log("[modValue.bas] -> [getArrayOfArray] -> [" & LastException.message & "]")
		Return Null
	End Try
End Sub

public Sub get(avalue As Object,apath As String,adefault As Object,aseparator As String) As Object
	Try
		Dim r As Object=adefault
		Dim o As Object=avalue
		Dim i As Int=0
		Dim t As Boolean=False
		Dim s() As String=Regex.split("\" & aseparator, apath)
		Dim u As String
		Dim d As Int
		Try
			Do While Not(t)
				If o Is Map Then
					o=getMap(o,s(i),adefault)
				Else
					If o Is List Then
						o=getList(o,s(i),adefault)
					Else
						u=GetType(o)
						d=s(i)
						If u="[Lanywheresoftware.b4a.objects.collections.Map;" Then
							o=getArrayOfMap(o,d)
						Else
							If u="[Lanywheresoftware.b4a.objects.collections.List;" Then
								o=getArrayOfList(o,d)
							Else
								If u.SubString2(0,2)="[[" Then
									o=getArrayOfArray(o,d)
								Else
									Select Case u.SubString2(1,2)
										Case "B"
											o=getArray_B(o,d)
										Case "C"
											o=getArray_C(o,d)
										Case "S"
											o=getArray_S(o,d)
										Case "I"
											o=getArray_I(o,d)
										Case "J"
											o=getArray_J(o,d)
										Case "F"
											o=getArray_F(o,d)
										Case "D"
											o=getArray_D(o,d)
										Case "L"
											o=getArray_L(o,d)
										Case Else
											t=True
											o=adefault
									End Select
								End If
							End If
						End If
					End If
				End If
				If Not(t) Then
					i=i+1
					If i=s.Length Then
						t=True
						r=o
					End If
				End If
			Loop
		Catch
			Log("[modValue.bas] -> [get] -> [" & LastException.message & "]")
		End Try
		Return r
	Catch
		Log("[modValue.bas] -> [get] -> [" & LastException.message & "]")
		Return Null
	End Try
End Sub

Public Sub ifnull(avalue As Object,adefault As Object) As Object
	If avalue=Null Then
		avalue=adefault
	End If
	Return avalue
End Sub

public Sub GetAsMap(avalue As Object,apath As String,adefault As Object,aseparator As String) As Map
	Try
		Return ifnull(get(avalue,apath,adefault,aseparator),adefault)
	Catch
		Log("[modValue.bas] -> [GetAsMap] -> [" & LastException.message & "]")
		Return Null
	End Try
End Sub

public Sub GetAsList(avalue As Object,apath As String,adefault As Object,aseparator As String) As List
	Try
		Return ifnull(get(avalue,apath,adefault,aseparator),adefault)
	Catch
		Log("[modValue.bas] -> [GetAsList] -> [" & LastException.message & "]")
		Return Null
	End Try
End Sub

public Sub GetAsString(avalue As Object,apath As String,adefault As Object,aseparator As String) As String
	Try
		Return ifnull(get(avalue,apath,adefault,aseparator),adefault)
	Catch
		Log("[modValue.bas] -> [GetAsString] -> [" & LastException.message & "]")
		Return ""
	End Try
End Sub

public Sub GetAsInt(avalue As Object,apath As String,adefault As Object,aseparator As String) As Int
	Try
		Return ifnull(get(avalue,apath,adefault,aseparator),adefault)
	Catch
		Log("[modValue.bas] -> [GetAsInt] -> [" & LastException.message & "]")
		Return 0
	End Try
End Sub

public Sub GetAsLong(avalue As Object,apath As String,adefault As Object,aseparator As String) As Long
	Try
		Return ifnull(get(avalue,apath,adefault,aseparator),adefault)
	Catch
		Log("[modValue.bas] -> [GetAsLong] -> [" & LastException.message & "]")
		Return 0
	End Try
End Sub

public Sub GetAsFloat(avalue As Object,apath As String,adefault As Object,aseparator As String) As Float
	Try
		Return ifnull(get(avalue,apath,adefault,aseparator),adefault)
	Catch
		Log("[modValue.bas] -> [GetAsFloat] -> [" & LastException.message & "]")
		Return 0
	End Try
End Sub

public Sub GetAsDouble(avalue As Object,apath As String,adefault As Object,aseparator As String) As Double
	Try
		Return ifnull(get(avalue,apath,adefault,aseparator),adefault)
	Catch
		Log("[modValue.bas] -> [GetAsDouble] -> [" & LastException.message & "]")
		Return 0
	End Try
End Sub

public Sub GetAsBoolean(avalue As Object,apath As String,adefault As Object,aseparator As String) As Boolean
	Try
		Return ifnull(get(avalue,apath,adefault,aseparator),adefault)
	Catch
		Log("[modValue.bas] -> [GetAsBoolean] -> [" & LastException.message & "]")
		Return False
	End Try
End Sub
