﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.3
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private fVarName As String
	Private fViewName As String
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(aVarName As String,aViewName As String)
	setVarName(aVarName)
	setViewName(aViewName)
End Sub

public Sub setVarName(avalue As String)
	fVarName=avalue
End Sub
public Sub getVarName As String
	Return fVarName
End Sub
public Sub setViewName (avalue As String)
	fViewName=avalue
End Sub
public Sub getViewName As String
	Return fViewName
End Sub

public Sub run(alist As List) As String
	Dim s As String=$"dim ${fVarName} as csBuilder${CRLF}${fVarName}.initialize${CRLF}"$
	s=s & generate(alist)
	If s.Contains($"${fVarName}.clickable("$) Then
		s=s & $"${fVarName}.EnableClickEvents(${fViewName})"$ & CRLF
	End If
	Return s
End Sub

private Sub generate(alist As List) As String
	Dim s As String=""
	If alist.IsInitialized Then
		For Each span As Map In alist
			s=s & CallSub2(Me,"code_" & span.Get("span"),span) & CRLF
			s=s & generate(span.GetDefault("spans",Null))
			If span.ContainsKey("spans") Then
				s=s & $"${fVarName}.pop${CRLF}"$
			End If
		Next
	End If
	Return s
End Sub

private Sub code_append(aspan As Map) As String
	Dim v As String=aspan.Get("append")
	Return  $"${fVarName}.append($"${v.Replace("\n","CRLF")}"${"$"})"$
End Sub

private Sub code_icon(aspan As Map) As String
	Return  $"${fVarName}.typeface(typeface.${aspan.Get("typeface")}).append(chr(0x${aspan.Get("code")})).pop"$
End Sub

private Sub code_bold(aspan As Map) As String
	Return $"${fVarName}.bold"$
End Sub

private Sub code_underline(aspan As Map) As String
	Return $"${fVarName}.underline"$
End Sub

private Sub code_strikethrough(aspan As Map) As String
	Return $"${fVarName}.strikethrough"$
End Sub

private Sub code_typeface(aspan As Map) As String
	Return  $"${fVarName}.typeface(typeface.createNew(typeface.${aspan.Get("typeface")},typeface.${aspan.Get("style")}))"$
End Sub

private Sub code_Alignment(aspan As Map) As String
	Return  $"${fVarName}.alignment("${aspan.Get("alignment")}")"$
End Sub

private Sub code_VerticalAlign(aspan As Map) As String
	Return  $"${fVarName}.verticalAlign(${aspan.Get("shift")}dip)"$
End Sub

private Sub code_Size(aspan As Map) As String
	Return  $"${fVarName}.size(${aspan.Get("size")})"$
End Sub

private Sub code_relativeSize(aspan As Map) As String
	Return  $"${fVarName}.relativeSize(${aspan.Get("proportion")})"$
End Sub

private Sub code_scaleX(aspan As Map) As String
	Return  $"${fVarName}.scaleX(${aspan.Get("proportion")})"$
End Sub

private Sub code_image(aspan As Map) As String
	Return  $"${fVarName}.image(loadBitmap(file.dirAssets,"${File.GetName(aspan.Get("bmp"))}"),${aspan.Get("width")},${aspan.Get("height")},${aspan.Get("baseline")})"$
End Sub

private Sub code_clickable(aspan As Map) As String
	Return  $"${fVarName}.clickable("${aspan.Get("eventName")}","${aspan.Get("tag")}")"$
End Sub

private Sub code_color(aspan As Map) As String
	Return  $"${fVarName}.color(0x${aspan.Get("color")})"$
End Sub

private Sub code_backgroundColor(aspan As Map) As String
	Return  $"${fVarName}.backgroundColor(0x${aspan.Get("backgroundColor")})"$
End Sub
