﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.3
@EndOfDesignText@
#event : click(atag as string)
Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	Private fBmp As Image
	Private fIcons() As String
	Private fMenuBar As MenuBar
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
    Tag = mBase.Tag
    mBase.Tag = Me 
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub

public Sub build(abmp As Image,aicons() As String,amenubar As MenuBar)
	fBmp=abmp
	fIcons=aicons
	fMenuBar=amenubar
	Dim l As Int=0
	Dim t As String=""
	Dim n As Int=0
	For i=0 To fIcons.Length-1
		t=fIcons(i)
		If t="-" Then
			l=l+6
		Else
			Dim iv As ImageView
			iv.Initialize("toolbar")
			iv.Tag=t
			DrawIcon(fBmp,n,0,iv)
			mBase.Addview(iv,l,2,26,26)
			toolTipOnNode(iv,TooltipText(fMenuBar.Menus,t),True)
			l=l+30
			n=n+1
		End If
	Next
End Sub

private Sub TooltipText(aitems As List,atag As String) As String
	For Each mi As MenuItem In aitems
		If (mi.Tag<>Null) And (mi.Tag<>"") And (mi.Tag=atag) Then
			Return mi.Text
		Else
			If mi Is Menu Then
				Dim mn As Menu=mi
				Dim s As String=TooltipText(mn.MenuItems,atag)
				If s<>"" Then
					Return s
				End If
			End If
		End If
	Next
	Return ""
End Sub

private Sub DrawIcon(aImg As Image,aindex As Int,aStatus As Int,aImageView As ImageView)
	Dim tb As BitmapCreator
	Dim s As Int=Min(aImg.Width,aImg.Height)
	tb.Initialize(aImg.Width,aImg.Height)
	Dim r As B4XRect
	r.Initialize(0,0,aImg.Width,aImg.Height)
	tb.DrawBitmap(aImg,r,True)
	Dim bc As BitmapCreator
	r.Initialize(s*aindex,0,s*(aindex+1),s)
	bc.Initialize(s,s)
	Select Case aStatus
		Case 0
			bc.DrawBitmapCreator(tb,r,0,0,True)
		Case 1
			bc.DrawBitmapCreator(tb,r,2,2,True)
		Case 2
			'https://www.b4x.com/android/forum/threads/b4x-bitmapcreator-effects.93608/
			Dim e As BitmapCreatorEffects
			e.Initialize
			bc.DrawBitmapCreator(tb,r,0,0,True)
			r.Initialize(0,0,s,s)
			bc.DrawBitmap(e.GreyScale(bc.Bitmap),r,True)
	End Select
	bc.SetBitmapToImageView(bc.Bitmap,aImageView)
End Sub

'https://www.b4x.com/android/forum/threads/add-a-tooltip-to-an-imageview.65439/post-673256
Private Sub toolTipOnNode(Nd As Node, msg As String, add As Boolean)
	Dim joToolTip As JavaObject
	Dim joToolTip2 As JavaObject = joToolTip.InitializeNewInstance("javafx.scene.control.Tooltip", Array(msg))
	joToolTip2.RunMethod("setStyle",Array("-fx-font-size: 20"))
	If add = True Then
		joToolTip.RunMethod("install", Array(Nd, joToolTip2))
	Else
		joToolTip.RunMethod("uninstall", Array(Nd, joToolTip2))
	End If
End Sub

private Sub toolbar_mouseclicked(aEvent As MouseEvent)
	Dim iv As ImageView=Sender
	CallSub2(mCallBack,mEventName & "_click",iv.Tag)
End Sub

private Sub findIcon(atag As String) As Int
	For i=0 To fIcons.Length-1
		Dim iv As ImageView=mBase.GetView(i)
		If iv.Tag=atag Then
			Return i
		End If
	Next
	Return -1
End Sub

private Sub toolbarIconDisabled(atag As String,adisabled As Boolean)
	Dim n As Int=findIcon(atag)
	Dim iv As ImageView=mBase.GetView(n)
	If adisabled Then
		DrawIcon(fBmp,n,2,iv)
	Else
		DrawIcon(fBmp,n,0,iv)
	End If
End Sub

private Sub toolbar_mousePressed(aEvent As MouseEvent)
	Dim iv As ImageView=Sender
	Dim n As Int=findIcon(iv.Tag)
	DrawIcon(fBmp,n,1,iv)
End Sub
	
private Sub toolbar_mouseReleased(aEvent As MouseEvent)
	Dim iv As ImageView=Sender
	Dim n As Int=findIcon(iv.Tag)
	DrawIcon(fBmp,n,0,iv)
End Sub

